import { CommonsType } from 'tscommons-core';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var EAdamantineFieldType = {
    SINGLE: 'single',
    MULTI: 'multi',
    BOOLEAN: 'boolean',
    INTEGER: 'integer',
    FLOAT: 'float',
    DATE: 'date',
    TIME: 'time',
    DATETIME: 'datetime',
    PHONE: 'phone',
    EMAIL: 'email',
    URL: 'url',
    LISTSET: 'listset',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IAdamantineField() { }
if (false) {
    /** @type {?} */
    IAdamantineField.prototype.name;
    /** @type {?} */
    IAdamantineField.prototype.description;
    /** @type {?} */
    IAdamantineField.prototype.type;
    /** @type {?|undefined} */
    IAdamantineField.prototype.optional;
    /** @type {?|undefined} */
    IAdamantineField.prototype.allow_multiple;
    /** @type {?|undefined} */
    IAdamantineField.prototype.listset;
}
/**
 * @param {?} test
 * @param {?=} ignoreListItems
 * @return {?}
 */
function isIAdamantineField(test, ignoreListItems) {
    if (ignoreListItems === void 0) { ignoreListItems = false; }
    if (!CommonsType.isObject(test))
        return false;
    if (!CommonsType.hasPropertyString(test, 'name'))
        return false;
    if (!CommonsType.hasPropertyString(test, 'description'))
        return false;
    if (!CommonsType.hasPropertyString(test, 'type'))
        return false;
    if (!CommonsType.hasPropertyBooleanOrUndefined(test, 'optional'))
        return false;
    if (test.type === EAdamantineFieldType.LISTSET) {
        if (!ignoreListItems)
            if (!CommonsType.hasProperty(test, 'listset') || !CommonsType.isStringArray(test.listset))
                return false;
        if (!CommonsType.hasPropertyBoolean(test, 'allow_multiple'))
            return false;
    }
    return true;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxAdamantineCommonsCoreModule = /** @class */ (function () {
    function NgxAdamantineCommonsCoreModule() {
    }
    NgxAdamantineCommonsCoreModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: []
                },] }
    ];
    return NgxAdamantineCommonsCoreModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { EAdamantineFieldType, NgxAdamantineCommonsCoreModule, isIAdamantineField };
//# sourceMappingURL=ngx-adamantinecommons-core.js.map
